---
title: JavaScript Guide
slug: Web/JavaScript/Guide
tags:
  - Guide
  - JavaScript
  - 'l10n:priority'
---
<div>{{jsSidebar("JavaScript Guide")}}</div>

<p class="summary">The JavaScript Guide shows you how to use <a href="/en-US/docs/Web/JavaScript">JavaScript</a> and gives an overview of the language. If you need exhaustive information about a language feature, have a look at the <a href="/en-US/docs/Web/JavaScript/Reference">JavaScript reference</a>.</p>

<p>This Guide is divided into the following chapters.</p>

<h2 id="Introduction"><span><a href="/en-US/docs/Web/JavaScript/Guide/Introduction">Introduction</a></span></h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Introduction#Where_to_find_JavaScript_information">About this guide</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Introduction#What_is_JavaScript">About JavaScript</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Introduction#JavaScript_and_Java">JavaScript and Java</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Introduction#JavaScript_and_the_ECMAScript_Specification">ECMAScript</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Introduction#Getting_started_with_JavaScript">Tools</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Introduction#Hello_world">Hello World</a></li>
</ul>

<h2 id="Grammar_and_types"><span><a href="/en-US/docs/Web/JavaScript/Guide/Grammar_and_types">Grammar and types</a></span></h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Grammar_and_types#Basics">Basic syntax &amp; comments</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Grammar_and_types#Declarations">Declarations</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Grammar_and_types#Variable_scope">Variable scope</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Grammar_and_types#Variable_hoisting">Variable hoisting</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Grammar_and_types#Data_structures_and_types">Data structures and types</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Grammar_and_types#Literals">Literals</a></li>
</ul>

<h2 id="Control_flow_and_error_handling"><span><a href="/en-US/docs/Web/JavaScript/Guide/Control_flow_and_error_handling">Control flow and error handling</a></span></h2>

<ul>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Control_flow_and_error_handling#if...else_statement">if...else</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Control_flow_and_error_handling#switch_statement">switch</a></code></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Control_flow_and_error_handling#Exception_handling_statements"><code>try</code>/<code>catch</code>/<code>throw</code></a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Control_flow_and_error_handling#Utilizing_Error_objects">Error objects</a></li>
</ul>

<h2 id="Loops_and_iteration"><span><a href="/en-US/docs/Web/JavaScript/Guide/Loops_and_iteration">Loops and iteration</a></span></h2>

<ul>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Loops_and_iteration#for_statement">for</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Loops_and_iteration#while_statement">while</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Loops_and_iteration#do...while_statement">do...while</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Loops_and_iteration#continue_statement">continue</a>/<a href="/en-US/docs/Web/JavaScript/Guide/Loops_and_iteration#break_statement">break</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Loops_and_iteration#for...in_statement">for..in</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Loops_and_iteration#for...of_statement">for..of</a></code></li>
</ul>

<h2 id="Functions"><span><a href="/en-US/docs/Web/JavaScript/Guide/Functions">Functions</a></span></h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Functions#Defining_functions">Defining functions</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Functions#Calling_functions">Calling functions</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Functions#Function_scope">Function scope</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Functions#Closures">Closures</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Functions#Using_the_arguments_object">Arguments</a> &amp; <a href="/en-US/docs/Web/JavaScript/Guide/Functions#Function_parameters">parameters</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Functions#Arrow_functions">Arrow functions</a></li>
</ul>

<h2 id="Expressions_and_operators"><span><a href="/en-US/docs/Web/JavaScript/Guide/Expressions_and_Operators">Expressions and operators</a></span></h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Expressions_and_Operators#Assignment_operators">Assignment</a> &amp; <a href="/en-US/docs/Web/JavaScript/Guide/Expressions_and_Operators#Comparison_operators">Comparisons</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Expressions_and_Operators#Arithmetic_operators">Arithmetic operators</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Expressions_and_Operators#Bitwise_operators">Bitwise</a> &amp; <a href="/en-US/docs/Web/JavaScript/Guide/Expressions_and_Operators#Logical_operators">logical operators</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Expressions_and_Operators#Conditional_(ternary)_operator">Conditional (ternary) operator</a></li>
</ul>

<h2 id="Numbers_and_dates"><span><a href="/en-US/docs/Web/JavaScript/Guide/Numbers_and_dates">Numbers and dates</a></span></h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Numbers_and_dates#Numbers">Number literals</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Numbers_and_dates#Number_object"><code>Number</code> object</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Numbers_and_dates#Math_object"><code>Math</code> object</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Numbers_and_dates#Date_object"><code>Date</code> object</a></li>
</ul>

<h2 id="Text_formatting"><span><a href="/en-US/docs/Web/JavaScript/Guide/Text_formatting">Text formatting</a></span></h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Text_formatting#String_literals">String literals</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Text_formatting#String_objects"><code>String</code> object</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Text_formatting#Multi-line_template_literals">Template literals</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Text_formatting#Internationalization">Internationalization</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions">Regular Expressions</a></li>
</ul>

<h2 id="Indexed_collections"><span><a href="/en-US/docs/Web/JavaScript/Guide/Indexed_collections">Indexed collections</a></span></h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Indexed_collections#Array_object">Arrays</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Indexed_collections#Typed_Arrays">Typed arrays</a></li>
</ul>

<h2 id="Keyed_collections"><span><a href="/en-US/docs/Web/JavaScript/Guide/Keyed_collections">Keyed collections</a></span></h2>

<ul>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Keyed_collections#Map_object">Map</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Keyed_collections#WeakMap_object">WeakMap</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Keyed_collections#Set_object">Set</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Keyed_collections#WeakSet_object">WeakSet</a></code></li>
</ul>

<h2 id="Working_with_objects"><span><a href="/en-US/docs/Web/JavaScript/Guide/Working_with_Objects">Working with objects</a></span></h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Working_with_Objects#Objects_and_properties">Objects and properties</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Working_with_Objects#Creating_new_objects">Creating objects</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Working_with_Objects#Defining_methods">Defining methods</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Working_with_Objects#Defining_getters_and_setters">Getter and setter</a></li>
</ul>

<h2 id="Details_of_the_object_model"><span><a href="/en-US/docs/Web/JavaScript/Guide/Details_of_the_Object_Model">Details of the object model</a></span></h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Details_of_the_Object_Model#Class-based_vs._prototype-based_languages">Prototype-based OOP</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Details_of_the_Object_Model#Creating_the_hierarchy">Creating object hierarchies</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Details_of_the_Object_Model#Property_inheritance_revisited">Inheritance</a></li>
</ul>

<h2 id="Promises"><span><a href="/en-US/docs/Web/JavaScript/Guide/Using_promises">Promises</a></span></h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Using_promises#Guarantees">Guarantees</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Using_promises#Chaining">Chaining</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Using_promises#Error_propagation">Error propagation</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Using_promises#Composition">Composition</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Using_promises#Timing">Timing</a></li>
</ul>

<h2 id="Iterators_and_generators"><span><a href="/en-US/docs/Web/JavaScript/Guide/Iterators_and_Generators">Iterators and generators</a></span></h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Iterators_and_Generators#Iterators">Iterators</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Iterators_and_Generators#Iterables">Iterables</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Iterators_and_Generators#Generators">Generators</a></li>
</ul>

<h2 id="Meta_programming"><span><a href="/en-US/docs/Web/JavaScript/Guide/Meta_programming">Meta programming</a></span></h2>

<ul>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Meta_programming#Proxies">Proxy</a></code></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Meta_programming#Handlers_and_traps">Handlers and traps</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Meta_programming#Revocable_Proxy">Revocable Proxy</a></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Guide/Meta_programming#Reflection">Reflect</a></code></li>
</ul>

<h2 id="JavaScript_modules"><span><a href="/en-US/docs/Web/JavaScript/Guide/Modules">JavaScript modules</a></span></h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Modules#Exporting_module_features">Exporting</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Modules#Importing_features_into_your_script">Importing</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Modules#Default_exports_versus_named_exports">Default exports</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Modules#Renaming_imports_and_exports">Renaming features</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Modules#Aggregating_modules">Aggregating modules</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Modules#Dynamic_module_loading">Dynamic module loading</a></li>
</ul>

<p>{{Next("Web/JavaScript/Guide/Introduction")}}</p>
